global santexToolbox_new_toolset

rollout santexToolbox_new_toolset "santexToolbox - Create new toolset" width:340 height:200
(
	local cfgdir=((getdir #maxroot)+"plugcfg\\santexTools\\santexToolbox\\")
	local ui_min_size = [340,200]
	
	edittext edt_name "* Name:" width:320
	edittext edt_author "* Author:" width:320
	edittext edt_desc "Description: " width:320 height:64
	edittext edt_dir "* ... \\ santexToolbox \\" width:320
	
	button btn_ok "CREATE" width:120 height:32 pos:[(340-230),156]
	button btn_cancel "Cancel" width:80 height:32 pos:[240,156]
	
	include "santex_fnlib.ms"
	
	fn create_folder dir=
	(
		makeDir dir all:true
	)
	fn create_config_file dir filename=
	(
		maintitle = "santexToolbox"
		slib.file.init (dir+filename+"-toolset.ini") ("Toolset config file ("+filename+"-toolset.ini)")
	)
	fn resizeUI new_size=
	(
		ui_max_size=[(systemTools.GetScreenWidth() - 10),(systemTools.GetScreenHeight() - 100)]
		dlg_size=slib.dlg.resizelim santexToolbox_new_toolset new_size ui_min_size ui_max_size
		
		btn_cancel.pos.y=dlg_size.y-45
		btn_ok.pos.y=dlg_size.y-45
		btn_cancel.pos.x=dlg_size.x-100
		btn_ok.pos.x=dlg_size.x-100-100-30
		
		edt_name.width = dlg_size.x-76
		edt_author.width = dlg_size.x-82
		edt_desc.width = dlg_size.x-96
		edt_dir.width = dlg_size.x-144
		
		edt_dir.pos.y = dlg_size.y-80
		
		edt_desc.height = dlg_size.y - 140
	)
	fn get_dir_array=
	(
		local temparr = #()
		local dirs=getDirectories (cfgdir+"*")
		if(dirs.count>0)do
		(
			for i=1 to dirs.count do
			(
				append temparr ((filterString (dirs[i]) "\\")[(filterString (dirs[i]) "\\").count])
			)
		)
		
		return temparr
	)
	fn create_new_toolset=
	(
		if(edt_name.text!="" AND edt_author.text!="" AND edt_dir.text!="")then
		(
			--local dir_array = 
			local proceed_next = false
			if(findItem (get_dir_array()) edt_dir.text==0)then
			(
				proceed_next = true
			)else
			(
				--messagebox "Please enter another folder name, specified folder already exists!" title:"Error"
				if(querybox "Specified folder already exists! Do you really want to continue?") then proceed_next = true else proceed_next = false
			)
				
			if(proceed_next)do
			(
			local today_date = getLocalTime()
			today_date = (today_date[4] as string +"."+today_date[2] as string+"."+today_date[1] as string) as string
			local new_toolset = toolset_struct name:edt_name.text\
															author:edt_author.text\
															dir:edt_dir.text\
															desc:edt_desc.text\
															created:today_date
			append all_toolsets new_toolset
			create_folder (cfgdir + edt_dir.text + "\\")
			create_config_file (cfgdir + edt_dir.text + "\\") edt_dir.text
			
			local ccfg_filename = ((cfgdir + edt_dir.text + "\\") +edt_dir.text+"-toolset.ini")
			slib.csetting.save ccfg_filename "General" "name" edt_name.text
			slib.csetting.save ccfg_filename "General" "author" edt_author.text
			slib.csetting.save ccfg_filename "General" "desc" edt_desc.text
			slib.csetting.save ccfg_filename "General" "created" today_date
			
			--print new_toolset
			destroydialog santexToolbox_new_toolset
			santexToolbox.refresh_toolset_list()
			)
			
		)else messagebox "Please fill in Name, Author and folder name!" title:"Error"
	)
	on btn_ok pressed do
	(
		create_new_toolset()
	)
	--on edt_dir entered txt do create_new_toolset()
	--on edt_name entered txt do create_new_toolset()
	--on edt_author entered txt do create_new_toolset()
	on btn_cancel pressed do
	(
		destroydialog santexToolbox_new_toolset
	)
	on santexToolbox_new_toolset open do
	(
		slib.dlg.setSize santexToolbox_new_toolset (slib.setting.load "santexToolbox_new_toolset.size" (getDialogSize santexToolbox_new_toolset))
		resizeUI (slib.dlg.getSize santexToolbox_new_toolset)
		slib.dlg.setPos santexToolbox_new_toolset (slib.setting.load "santexToolbox_new_toolset.pos" [0,0])
			setFocus santexToolbox_new_toolset.edt_name
	)
	on santexToolbox_new_toolset close do
	(
		slib.setting.save "santexToolbox_new_toolset.pos" (getDialogPos santexToolbox_new_toolset)
		slib.setting.save "santexToolbox_new_toolset.size" (getDialogSize santexToolbox_new_toolset)
	)
	on santexToolbox_new_toolset resized new_size do resizeUI new_size
)
createdialog santexToolbox_new_toolset style:#(#style_border,#style_titlebar,#style_resizing) modal:true